# Timed Torches Stay Lit - Server Sync

## Was TimedTorches_Fixed now TimedTorchesStayLit


### UPDATED - Completely redone and simplified for Mistlands Update.

After months of dealing with feature creep and requested options, the old mod had become beyond broken. I removed almost every option to simplify the code
and bring this back in line with my own gameplay.  Therefore I rewrote and relaunched the entire mod, hence the new Mod name.

- Serversync is finally implemented - Thank you Azumatt for the amazing youtube tutorial
- Sorry if a certain feature you like was removed.  I have no plans to bring them back. 
- The code will be posted on Github if anyone wants to take add in the desired features.

### Items that can be configured

- Time on and Time off for torches
- Items affected by this mod
- Option to use fuel or never need fuel. (Never need fuel is the default, hence the Stay Lit)



## Fixed for Valheim Mistlands Update
- This has been fixed for the Valheim Mistlands Update  
- I will do my best to answer questions and fix issues.


### About the Mod
I wanted my torches to turn on at night and off during the day.  I also did not want to fuel them.

## Serversync is finally implemented.  Server and players need it.  The server will send down the config..


### Configuration


<b>If you leave the settings alone, torches will turn off at 7:30am and turn on at 4:30pm and require NO fuel.</b>

<b>To Configure if the server locks the config and forces users to have the same settings</b>

- ServerConfig Locked - locks the config files so all clients have the same config and cannot change. Default true

The config file is located in "<GameDirectory>\Bepinex\config" (You need to start the game at least once, with the mod installed to create the config file).

<b>To view or add items this mod affects:  </b>

- AffectedFireplaceSources - List of objects to be affected by the mod (see below for list of supported objects). By default vanilla torches are added.

<b>To configure the timer:</b>
 
- OnTime - Time of day when torches should turn ON. (The default is set to 4.30pm in-game time)
- OffTime - Time of day when torches should turn OFF. (The default is set to 6.30am in-game time)

- AlwaysOnInDarkBiomes - (Default True) If true, objects listed in AffectedFireplaceSources will always burn in areas that Valheim considers 'always dark'. E.g Mistlands or any biome during a storm.

- AllowAddingFuel - (Default False) If true, fuel can be added and sources will use the timer settings.  If false no fuel is needed to burn torches
 

Note: If OnTime and OffTime is set to the same value, for example 0 and 0 the fireplaces listed in AffectedFireplaceSources will burn 24/7.

The config file is located in "<GameDirectory>\Bepinex\config" (You need to start the game with the mod installed for the config file to be created).

### List of supported objects:
  
piece_groundtorch  
piece_groundtorch_wood  
piece_groundtorch_green  
piece_brazierceiling01  
piece_walltorch  
hearth  
bonfire  
fire_pit  
piece_jackoturnip  
piece_brazierfloor01 - (New with Frost Caves)

(New in Mistlands)
Lantern 
piece_dvergr_lantern
piece_dvergr_lantern_pole

- Custom modded items can be added as well.  Example rk_campfire for the smokeless campfire in the Bon Appetit mod.

### Other

How to find the perfect timer settings for your needs  

The default values are set to work for my base that doesn't get really early sun and not the last rays of the sunset. However, if your base is in a different location you might want to tweak the on and off times.
This is how you go about finding a timing that's right for you!  

- Take the time you want to turn the lantern on or off and convert it to military time (24 hour time)
- divide that time by 24 and that's your time.
- For instance if you wanted the torches to turn off at 6:00pm
- 6:00pm is 18:00 (in 24 hour time).  18 / 24 = .75
.75 would be the turn off time



### Installation (manual)  
Extract DLL from zip file into "<GameDirectory>\Bepinex\plugins"  
Start the game.

### Note about Account

ThunderStore people will note that my username has changed to TastyChickenLeg instead of TastyChickenLegs.  I deleted my Github (was going to combine with work account then decided not to)
and forgot Thunderstore needed Github to login. So I can't get into my old TastyChickenLegs Team

- TimedTorches_Fixed will remain lifeless on Thunderstore (I can't access the account) unless someone knows how to fix that problem.

- I tried to get TastyChickenLegs back on Github but that's a no go too.  

### Version Information
Version 1.1.1

- ServerSync and versioncheck added.
- Fixed Interact bug when not using fuel
- Fix incompatibility with my NoSmokeStayLit mod

Version 1.0.0

- Intial release of mod - complete rewrite of TimedTorches_Fixed.
- Original Timed Torches mod was by Gurrlin.  Listed here for credit as this was originally his idea.

